'use strict';

angular.module('lmn.linbo_sync', ['core', 'lm.common']);


'use strict';

angular.module('lmn.linbo_sync').config(function ($routeProvider) {
    $routeProvider.when('/view/lmn/linbo_sync', {
        templateUrl: '/lmn_linbo_sync:resources/partial/index.html',
        controller: 'SyncIndexController'
    });
});


// Generated by CoffeeScript 2.4.1
(function() {
  angular.module('lmn.linbo_sync').controller('SyncIndexController', function($scope, $http, $interval, $timeout, notify, pageTitle, messagebox, gettext) {
    pageTitle.set(gettext('Linbo synchronization'));
    $http.get("/api/lm/linbo/SyncList").then(function(resp) {
      var group, results;
      $scope.groups = resp.data;
      $scope.linbo_command = {};
      results = [];
      for (group in $scope.groups) {
        results.push($scope.linbo_command[group] = {
          'cmd': [],
          'show': false,
          'host': [],
          'target': 'clients'
        });
      }
      return results;
    });
    $scope.isUp = function(group, host) {
      var index;
      index = $scope.groups[group].hosts.indexOf(host);
      return $http.get(`/api/lm/linbo/isOnline/${host.host}`).then(function(resp) {
        $scope.groups[group].hosts[index].up = resp.data;
        if (resp.data === "Off") {
          return $scope.groups[group].hosts[index].upClass = "btn-danger";
        } else {
          return $scope.groups[group].hosts[index].upClass = "btn-success";
        }
      });
    };
    $scope.checkOnline = function(group) {
      var host, i, len, ref, results;
      ref = $scope.groups[group].hosts;
      results = [];
      for (i = 0, len = ref.length; i < len; i++) {
        host = ref[i];
        results.push($scope.isUp(group, host));
      }
      return results;
    };
    $scope.clientIsInCmd = function(group, ip) {
      return $scope.linbo_command[group]['host'].indexOf(ip) > -1 || $scope.linbo_command[group]['target'] === 'group';
    };
    $scope.update_host = function(group, ip) {
      var host, i, len, position, ref;
      if (group === ip) {
        $scope.linbo_command[group]['host'] = [];
        if ($scope.linbo_command[group]['target'] === 'clients') {
          ref = $scope.groups[group].hosts;
          for (i = 0, len = ref.length; i < len; i++) {
            host = ref[i];
            $scope.linbo_command[group]['host'].push(host.ip);
          }
          $scope.linbo_command[group]['target'] = 'group';
        } else {
          $scope.linbo_command[group]['target'] = 'clients';
        }
      } else {
        $scope.linbo_command[group]['target'] = 'clients';
        position = $scope.linbo_command[group]['host'].indexOf(ip);
        if (position < 0) {
          $scope.linbo_command[group]['host'].push(ip);
        } else {
          $scope.linbo_command[group]['host'].splice(position, 1);
        }
      }
      return $scope.refresh_cmd(group);
    };
    $scope.handle_sync = function(group, os, value) {
      //# Possible values : new, sync or 0
      if (value === 'new') {
        os.run_format = !os.run_format;
      } else {
        os.run_format = 0;
      }
      if (os.run_sync === value) {
        os.run_sync = 0;
      } else {
        os.run_sync = value;
      }
      return $scope.refresh_cmd(group);
    };
    $scope.handle_format = function(group, os, value) {
      //# Possible values : 1 or 0
      if (os.run_format === value) {
        os.run_format = 0;
      } else {
        os.run_format = value;
      }
      return $scope.refresh_cmd(group);
    };
    $scope.handle_start = function(group, os, value) {
      var i, len, osloop, ref;
      //# Possible values : start or 0
      if (os.run_start === value) {
        os.run_start = 0;
      } else {
        os.run_start = value;
      }
      ref = $scope.groups[group]['os'];
      //# Only one start possible
      for (i = 0, len = ref.length; i < len; i++) {
        osloop = ref[i];
        if (osloop.baseimage !== os.baseimage) {
          osloop.run_start = 0;
        }
      }
      return $scope.refresh_cmd(group);
    };
    $scope.handle_power = function(group, value) {
      //# Possible values : halt, reboot or 0
      if ($scope.groups[group]['power']['halt'] === value) {
        $scope.groups[group]['power']['halt'] = 0;
      } else {
        $scope.groups[group]['power']['halt'] = value;
      }
      return $scope.refresh_cmd(group);
    };
    $scope.refresh_cmd = function(group) {
      var cmd, format, i, ip, j, len, len1, os, ref, ref1, start, sync, timeout;
      cmd = ' -c ';
      format = [];
      sync = [];
      start = [];
      ref = $scope.groups[group]['os'];
      for (i = 0, len = ref.length; i < len; i++) {
        os = ref[i];
        //# First format
        if (os.run_format) {
          format.push('format:' + os.partition);
        }
        //# Then sync or new ( not both )
        if (os.run_sync) {
          sync.push('sync:' + os.partition);
        }
        //# A little start, but only one
        if (os.run_start) {
          start.push('start:' + os.partition);
        }
      }
      cmd += format.join();
      if (sync.length > 0) {
        cmd += cmd.length > 4 ? ',' + sync.join() : sync.join();
      }
      if (start.length > 0) {
        cmd += cmd.length > 4 ? ',' + start.join() : start.join();
      }
      //# Power is the key, but without start ...
      if ($scope.groups[group]['power']['halt']) {
        cmd += cmd.length > 4 ? ',' + $scope.groups[group]['power']['halt'] : $scope.groups[group]['power']['halt'];
      }
      timeout = '';
      if ($scope.groups[group]['power']['timeout'] > 0) {
        timeout = ' -w ' + $scope.groups[group]['power']['timeout'];
      }
      if (cmd.length > 4 && $scope.linbo_command[group]['host'].length > 0) {
        if ($scope.linbo_command[group]['target'] === 'group' || $scope.linbo_command[group]['host'].length === $scope.groups[group].hosts.length) {
          $scope.linbo_command[group]['target'] = 'group';
          $scope.linbo_command[group]['cmd'] = ['/usr/sbin/linbo-remote -g ' + group + timeout + cmd];
        } else {
          $scope.linbo_command[group]['cmd'] = [];
          ref1 = $scope.linbo_command[group]['host'];
          for (j = 0, len1 = ref1.length; j < len1; j++) {
            ip = ref1[j];
            $scope.linbo_command[group]['cmd'].push('/usr/sbin/linbo-remote -i ' + ip + timeout + cmd);
          }
        }
        return $scope.linbo_command[group]['show'] = true;
      } else {
        $scope.linbo_command[group]['cmd'] = '';
        return $scope.linbo_command[group]['show'] = false;
      }
    };
    return $scope.run = function(group) {
      var cmd, i, len, ref, results;
      ref = $scope.linbo_command[group]['cmd'];
      results = [];
      for (i = 0, len = ref.length; i < len; i++) {
        cmd = ref[i];
        results.push($http.post("/api/lm/linbo/run", {
          cmd: cmd,
          action: 'run-linbo'
        }).then(function(resp) {
          if (resp.data) {
            return notify.error(resp.data);
          } else {
            return notify.success(gettext('Command successfully sent : ') + cmd);
          }
        }));
      }
      return results;
    };
  });

}).call(this);

