angular.module('permissions').controller 'PermissionListIndexController', ($scope, $http, $interval, $timeout, notify, pageTitle, messagebox, gettext, config) ->
    pageTitle.set(gettext('List all permissions'))

    $scope.query = {
        'plugin': '',
        'sidebar': ''
    }

    $scope.roles = ['globaladministrator', 'schooladministrator', 'teacher', 'student']
    $http.get('/api/permissions').then (resp) ->

        $scope.pluginObj = resp.data[0]
        # To iterate in alphabetical order
        $scope.pluginList = Object.keys($scope.pluginObj)
        $scope.pluginList.sort()

        $scope.apiPermissions = resp.data[1]
        $scope.sidebarPermissions = resp.data[2]
        # To iterate in alphabetical order
        $scope.sidebarPermissionsList = Object.keys($scope.sidebarPermissions)
        $scope.sidebarPermissionsList.sort()

    $scope.get_provider = (url) ->
        if url.includes('/lm')
            return "Linuxmuster.net"
        if url.includes('/ni')
            return "Netzint"
        return "Ajenti"

    $scope.label_color = (provider) ->
        if provider == "Linuxmuster.net"
            return "warning"
        if provider == "Netzint"
            return "info"
        if provider == "Ajenti"
            return "default"

    $scope.iconify = (bool) ->
        if typeof(bool) == "undefined"
            return 'question'
        if bool == "true"
            return 'check'
        return 'times'

    $scope.colorize = (bool) ->
        if typeof(bool) == "undefined"
            return ''
        if bool == "true"
            return 'color:green'
        return 'color:red'

    $scope.count_rows = (plugin) ->
        return document.getElementById('table_'+plugin).rows.length > 1

    $scope.switch = (obj, role) ->
        # Set the filter to role
        # obj may be plugin or sidebar
        if $scope.query[obj] == role
            $scope.query[obj] = ''
        else
            $scope.query[obj] = role

    $scope.filter_sidebar = (url) ->
        details = $scope.sidebarPermissions[url]
        if $scope.roles.indexOf($scope.query.sidebar) != -1
            return details[$scope.query.sidebar] == "true"
        else
            return url.includes($scope.query.sidebar)
        return true

    $scope.filter_plugin = (plugin) ->
        if $scope.roles.indexOf($scope.query.plugin) != -1
            return true
        return plugin.includes($scope.query.plugin)

    $scope.filter_api = (details) ->
        if $scope.roles.indexOf($scope.query.plugin) != -1
            if details.permission_id
                return $scope.apiPermissions[details.permission_id][$scope.query.plugin] == "true"
            else
                return false
        return true